unit ModPlugPlayer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TModPlugPlayer = class(TPanel)
  private
    sik:boolean;
    hiden:boolean;
    Bgcolor,VU_color,sp_color,sp_colorhi,vu_colorhi:string;
    loop:boolean;
    filename:tfilename;
    stereo:boolean;
    player: pointer;
    playing:boolean;
    fonload:TNotifyEvent;
    fondeinit:TNotifyEvent;
    foninit:TNotifyEvent;
    fonstop:TNotifyEvent;
    stvers: dword;
   { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor destroy; override;
    procedure init;
    procedure deinit;
    procedure play;
    procedure stop;
    function ready: bool;
    function open: bool;
    function isplaying: bool;
    function version: dword;
    function getlength: dword;
    function getposition: dword;
    function Setposition(gotopos:integer): bool;
  published
    property SpectrumHide : boolean read hiden write hiden;
    property LoopSong : boolean read loop write loop;
    property SpectrumStereo : boolean read stereo write stereo;
    property SongName : tfilename read filename write Filename;
    property Seek : boolean read sik write sik;
    property OnLoad : TNotifyEvent read FOnLoad write FOnLoad;
    property OnDeinit : TNotifyEvent read FOndeinit write FOndeinit;
    property OnInit : TNotifyEvent read FOnInit write FOnInit;
    property OnStop : TNotifyEvent read FOnStop write FOnStop;
    property BackColor: string read  bgcolor write BgColor;
    property VUColor: string read  vu_color write vu_Color;
    property SPColor: string read  sp_color write sp_Color;
    property VUColorTop: string read  vu_colorhi write vu_Colorhi;
    property SPColorTop: string read  sp_colorhi write sp_Colorhi;
    property DllVersion: dword read  version write stvers;

    { Published declarations }
  end;


function CreateIt(parms : string) : pointer;stdcall;external 'npmod32.dll' name 'ModPlug_CreateEx'; {give her sum life!}
function LoadIt(plug : pointer;filename : string) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_Load'; {load her}
function PlayIt (it : pointer) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_Play'; {play it!}
function SetW(plug : pointer;hand : hwnd) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_SetWindow'; {assigns the plugin to the control}
function IsRead(plug : pointer) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_IsReady'; {am i ready to rocknroll?}
function DestroyIt(plug : pointer) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_Destroy'; {destroys pointer and player}
function StopIt(plug : pointer) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_Stop'; {stops the mod player}
function SetPos(plug : pointer; pos : word) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_SetCurrentPosition'; {set position}
function GetMaxPos(plug : pointer) : word;stdcall;external 'npmod32.dll' name 'ModPlug_GetMaxPosition'; {position}
function GetCurPos(plug : pointer) : word;stdcall;external 'npmod32.dll' name 'ModPlug_GetCurrentPosition'; {position}
function GetVersion:longint;stdcall;external 'npmod32.dll' name 'ModPlug_GetVersion';


  procedure Register;

implementation
Constructor TModPlugPlayer.create(AOwner: TComponent);
begin
  inherited Create(Aowner);    //
  player:= nil;
  self.width:=169;
  self.height:=49;
  bgcolor:='000000';
  vu_color:='00FF00';
  vu_colorhi:='FF0000';
  sp_color:='FF0000';
  sp_colorhi:='FFFF00';
end;

destructor TModPlugPlayer.Destroy;
begin
   deinit;
   inherited Destroy;
end;

procedure TModPlugPlayer.deinit;
begin
   if player = nil then exit;
   destroyit(player);
   if assigned(FOndeinit) then FOndeinit(self);
   player:=nil
end;

procedure tModPlugPlayer.init;
var
 hidden,lup,str,back,vu,sp,sphi,vuhi:string;
begin
if player <> nil then deinit;
if hiden = true then hidden:='true'
  else hidden:='false';
if loop = true then lup:='true'
  else lup:='false';
if stereo = true then str:='|controls|stereo';
//-------------------------------------
if  length(bgcolor) = 6 then
   begin
   back:='bgcolor|#'+bgcolor+'|';
   end
   else back:='bgcolor|#000000|';

if  length(sp_color) = 6 then
   begin
   sp:='spcolor|#'+sp_color+'|';
   end
   else sp:='';

if  length(sp_colorhi) = 6 then
   begin
   sphi:='spcolorhi|#'+sp_colorhi+'|';
   end
   else sphi:='';

if  length(vu_colorhi) = 6 then
   begin
   vuhi:='vucolorhi|#'+vu_colorhi+'|';
   end
   else vuhi:='';

if  length(vu_color) = 6 then
   begin
   vu:='vucolor|#'+vu_color+'|';
   end
   else vu:='';

//-------------------------------------
player:= createit(back+vu+sp+sphi+vuhi+'hidden|'+hidden+'|Title|'+self.caption+'|width|'+inttostr(self.width)+'|height|'
  +inttostr(self.height)+'|loop|'+lup+str+'');
setw(player,tpanel(self).handle);
if assigned(FOnInit) then FOnInit(self);
end;

procedure tModPlugPlayer.play;
begin
if player = nil then exit;
playit(player);
playing:=true;
end;

function tModPlugPlayer.ready: bool;
begin
if player <> nil then result:=isread(player)
else result:=false;
end;

function tModPlugPlayer.open: bool;
begin
if player <> nil then
begin;
if filename <> '' then loadit(player,filename);
end;
result:= isread(player);
if assigned(FOnLoad) then FOnLoad(self);
end;

function tModPlugPlayer.isplaying: bool;
begin
result:= playing;
end;

function tModPlugPlayer.version: dword;
 begin
  result:=getversion;
 end;

function tModPlugPlayer.getlength: Dword;
begin
if player <> nil then
begin;
result:=getmaxpos(Player);
end
else result:=0;
end;

function tModPlugPlayer.getposition: Dword;
begin
if player <> nil then
begin;
result:=getcurpos(Player);
end
else result:=0;
end;

function tModPlugPlayer.Setposition(gotopos: integer): bool;
begin
if not sik then setposition:=false;
if not sik then exit;
if player = nil then
begin
result:=false;
exit;
end;
  if gotopos < getmaxpos(Player) then
  begin
  result:=setpos(Player, gotopos);
  end
  else
  result:=false;
end;

procedure tModPlugPlayer.stop;
begin
if player <> nil then
begin;
stopit(player);
playing:=false;
if assigned(FOnstop) then FOnstop(self);
end;
end;

procedure Register;
begin
  RegisterComponents('Multimedia', [TModPlugPlayer]);
end;

end.
